/*
 * DistPi
 * DistPi.x10
 * Karen Tomko
 * Ohio Supercomputer Center
 */

import x10.util.Random;

public class DistPi {
	public static def main(args: Array[String](1)) {
		val samplesPerPlace = 10000;
		val localCounts = DistArray.make[Double](Dist.makeUnique(), 0.0);
		finish for (p in localCounts.dist.places()) {
			async at (p) {
				val seed = 13+here.id;
				val r = new Random(seed);
				for (i in 1..samplesPerPlace) {
					val x = r.nextDouble();
					val y = r.nextDouble();
					val z = x*x+y*y;
					if ((x*x + y*y) <= 1.0) {
						localCounts(here.id)++;
					}
				}
			}
		}
		var globalCount:Double = 0.0;
		for (p in localCounts.dist.places()) {
			globalCount += (at (p) localCounts(here.id));
		}
		val pi = 4*(globalCount/(samplesPerPlace*here.MAX_PLACES as Double));
		Console.OUT.println("With "+samplesPerPlace*here.MAX_PLACES+" points, the value of pi is " + pi);
	}
}
