/*
 * DistTest
 * Driver.x10
 * Dave Hudak
 * Ohio Supercomputer Center
 */

class Driver {
	static def show(s:String, d:Dist) {
		x10.io.Console.OUT.print(s + " = ");
		for(p in d.region) 
			x10.io.Console.OUT.print(" " + d(p).id);
		x10.io.Console.OUT.println("");
	}
	
	public static def main(args:Array[String](1)) {
		val arraySize = 12;
		val R = 1..arraySize;
		show("R -> here ", R -> here);
		show("Dist.makeUnique() ", Dist.makeUnique());
		show("Dist.makeBlock(R) ", Dist.makeBlock(R));
		show("Dist.makeBlock(R)|here", Dist.makeBlock(R)|here);
		val testArray = DistArray.make[Int](Dist.makeBlock(R), ([i]:Point)=>i);
		val localSum = DistArray.make[Int](Dist.makeUnique(), ((Point)=>0));
		finish {
			for (p in testArray.dist.places()) {
				async at (p) {
					for (localPoint in testArray.dist|here) {
						localSum(p.id) += testArray(localPoint);
					}
				}
			}
		}
		var globalSum:Int = 0;
		for (p in localSum.dist.places()) {
			globalSum += (at (p) localSum(p.id));
		}
		Console.OUT.println("Sum of 1..arraySize = "+globalSum);
		val product = (((arraySize + 1) * arraySize) / 2) as Int;
		Console.OUT.println("((arraySize + 1)*arraySize)/2 = "+globalSum);
		
		/*
		 * Test of a DistArray of counter objects
		 */
		val counterArray = DistArray.make[Counter](Dist.makeUnique());
		val counterArrayPlaces = counterArray.dist.places();
		for (p in counterArrayPlaces) {
			at (p) {
				counterArray(p.id) = new Counter(p.id);
			}
		}
		for (p in counterArrayPlaces) {
			at (p) {
				val myCounter = counterArray(p.id);				
				val myCounterValue = myCounter.getCount();
				Console.OUT.println("Start "+p.id+":  myCounter = "+myCounterValue);
			}
		}
		for (p in counterArrayPlaces) {
			at (p) {
				val myCounter = counterArray(p.id);
				for ([i] in 1..5) {
					myCounter.count();
				}
			}
		}
		for (p in counterArrayPlaces) {
			at (p) {
				val myCounter = counterArray(p.id);				
				val myCounterValue = myCounter.getCount();
				Console.OUT.println("End "+p.id+":  myCounter = "+myCounterValue);
			}
		}
		/*
		 * Test of regions
		 */
		val blockDist = Dist.makeBlock(R);
		val p0Dist = blockDist|here;
		val p0Region = p0Dist.region;
		Console.OUT.println("p0Region.min(0) = "+p0Region.min(0));
		Console.OUT.println("p0Region.max(0) = "+p0Region.max(0));
		for ([p] in p0Region) {
			Console.OUT.println("p0 = "+p);
		}
		at (Place.places()(1)) {
			val p1Dist = blockDist|here;
			val p1Region = p1Dist.region;
			Console.OUT.println("p1Region.min(0) = "+p1Region.min(0));
			Console.OUT.println("p1Region.max(0) = "+p1Region.max(0));
			for ([p] in p1Region) {
				Console.OUT.println("p1 = "+p);
			}    
		}
	}
}