/*
 * MLPrefixSum 
 * Driver.x10
 * Dave Hudak
 * Ohio Supercomputer Center
 */

public class Driver {
	
	public static def testPrefixSum(val psf:  PrefixSumFactory,
			val arraySize: Int) {
		val mlpsObject = new MLPrefixSum(psf, arraySize);
		val beforePS =  mlpsObject.str();
		Console.OUT.println("Initial array:  "+beforePS);
		mlpsObject.computeSum();
		val afterPS = mlpsObject.str();
		Console.OUT.println("After prefix sum:  "+afterPS);
	}
	
	public static def main(args:Array[String](1)) {
		val arraySize = 32;									
		
		Console.OUT.println("MLPrefixSum (serial) test:");
		val getSerialPS = new PrefixSumFactory();
		testPrefixSum(getSerialPS, arraySize);
		
		Console.OUT.println("MLPrefixSum (async) test:");
		val getAsyncPS = new PrefixSumFactory(true);
		testPrefixSum(getAsyncPS, arraySize);
		
	}
}