/*
 * MLPrefixSum
 * PrefixSumFactory.x10 
 * Dave Hudak
 * Ohio Supercomputer Center
 */

public class PrefixSumFactory {
	
	val debug: Boolean;
	
	public def this() {
		debug = true;
	}
	
	public def this(testMode:Boolean) {
		debug = testMode;
	}
	
	public def getPrefixSum(): PrefixSum {
		if (debug) {
			val p = new PrefixSum();
			return p;
		}
		else {
			val p = new AsyncPrefixSum();
			return p;
		}
	} 
	
	public def getPrefixSum(length:Int): PrefixSum {
		if (debug) {
			val p = new PrefixSum(length);
			return p;
		}
		else {
			val p = new AsyncPrefixSum(length);
			return p;
		}
	} 
	
	public def getPrefixSum(lowerBound:Int, upperBound:Int): PrefixSum {
		if (debug) {
			val p = new PrefixSum(lowerBound, upperBound);
			return p;
		}
		else {
			val p = new AsyncPrefixSum(lowerBound, upperBound);
			return p;
		}
	} 
}