/*
 *  This file is part of the X10 project (http://x10-lang.org).
 * 
 *  This file is licensed to You under the Eclipse Public License (EPL);
 *  You may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *      http://www.opensource.org/licenses/eclipse-1.0.php
 * 
 *  (C) Copyright IBM Corporation 2006-2010.
 */

import x10.util.Random;

public class AsyncPi {
	public static def main(args: Array[String](1)) {
		val samplesPerActivity = 10000;
		val numActivities = 8;
		val activityCounts = new Array[Double](1..numActivities, 0.0);
		finish for (activityID in 1..numActivities) {
			async {
				val activityIndex = activityID;
				val r = new Random(activityIndex);
				for (i in 1..samplesPerActivity) {
					val x = r.nextDouble();
					val y = r.nextDouble();
					val z = x*x+y*y;
					if ((x*x + y*y) <= 1.0) {
						activityCounts(activityID)++;
					}
				}
			}
		}
		var globalCount:Double = 0.0;
		for (activityID in 1..numActivities) {
			globalCount += activityCounts(activityID);
		}
		val pi = 4*(globalCount/(samplesPerActivity*numActivities as Double)); 
		Console.OUT.println("With "+samplesPerActivity*numActivities+" points, the value of pi is " + pi);
	}
}
